SystemOrganization addCategory: #'Parcial<RagaLlorens>'!

OrderedCollection subclass: #Matriu
	instanceVariableNames: 'n'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Parcial<RagaLlorens>'!

!Matriu class methodsFor: 'instance creation' stamp: 'NatxoRaga 11/5/2012 23:42'!
identity: aNumber

	| matriu |
	matriu := self new: aNumber.
	
	(1 to: self n) do: [ :row | 
		(1 to: self n) do: [ :col |  row = col ifTrue: [matriu at: (row@col) put: 1]]].
	^ matriu
! !

!Matriu class methodsFor: 'instance creation' stamp: 'NatxoRaga 11/6/2012 17:37'!
new: aNumber

	| matriu |
	matriu := super new: aNumber * aNumber.
	matriu initialize: aNumber.
	^ matriu! !

!Matriu methodsFor: 'arithmetic' stamp: 'NatxoRaga 11/9/2012 22:03'!
* aFactor
	"Precondition: aFactor must be a matriu or a number"

	| matMult |

	(aFactor class asString = Matriu asString) 
		ifTrue: [(self n = aFactor n) ifFalse: [self error: 'No es poden multiplicar dues matrius de diferent tamany'].
			      matMult := Matriu new: self n.
				(1 to: self n) do: [ :row | 
					(1 to: self n) do: [ :col | matMult at: (row@col) put: 0.
						(1 to: self n) do: [ :index | matMult at: (row@col) put: (matMult at: row@col) + 
																		         ((self at: row@index) * 
																			   (aFactor at: index@col))]]].
				^ matMult]
		ifFalse: [matMult := Matriu new: self n.
				(1 to: self n) do: [ :row | 
					(1 to: self n) do: [ :col | matMult at: (row@col) put: (self at: row@col) * aFactor]].
				^ matMult]

	
	
! !

!Matriu methodsFor: 'arithmetic' stamp: 'NatxoRaga 11/5/2012 22:27'!
+ aSumand
	"Precondition: aSumand must be a matriu or a number"

	| matSuma |

	(aSumand class asString = Matriu asString) 
		ifTrue: [(self n = aSumand n) ifFalse: [self error: 'No es poden sumar dues matrius de diferent tamany'].
			      matSuma := Matriu new: self n.
				(1 to: self n) do: [ :row | 
					(1 to: self n) do: [ :col | matSuma at: (row@col) put: (self at: row@col) + (aSumand at: row@col)]].
				^ matSuma]
		ifFalse: [matSuma := Matriu new: self n.
				(1 to: self n) do: [ :row | 
					(1 to: self n) do: [ :col | matSuma at: (row@col) put: (self at: row@col) + aSumand]].
				^ matSuma]

	
	
! !

!Matriu methodsFor: 'arithmetic' stamp: 'NatxoRaga 11/9/2012 21:48'!
- aSubstrahend
	"Precondition: aSubstrahend must be a matriu or a number"

	| matDiff |

	(aSubstrahend class asString = Matriu asString) 
		ifTrue: [(self n = aSubstrahend n) ifFalse: [self error: 'No es poden restar dues matrius de diferent tamany'].
			      matDiff := Matriu new: self n.
				(1 to: self n) do: [ :row | 
					(1 to: self n) do: [ :col | matDiff at: (row@col) put: (self at: row@col) - (aSubstrahend at: row@col)]].
				^ matDiff]
		ifFalse: [matDiff := Matriu new: self n.
				(1 to: self n) do: [ :row | 
					(1 to: self n) do: [ :col | matDiff at: (row@col) put: (self at: row@col) - aSubstrahend]].
				^ matDiff]

	
! !

!Matriu methodsFor: 'accessing' stamp: 'NatxoRaga 11/6/2012 17:40'!
at: aPair
	"Precondition: aPair must be of type (x@y), not a normal index."

	^ self at: aPair x at: aPair y! !

!Matriu methodsFor: 'accessing' stamp: 'NatxoRaga 11/5/2012 21:18'!
at: aRow at: aCol

	^ super at: (self indexForRow: aRow andColumn: aCol) ! !

!Matriu methodsFor: 'accessing' stamp: 'NatxoRaga 11/5/2012 01:02'!
at: aRow at: aCol put: aValue

	^ super at: (self indexForRow: aRow andColumn: aCol) put: aValue. ! !

!Matriu methodsFor: 'accessing' stamp: 'NatxoRaga 11/6/2012 17:40'!
at: aPair put: aValue
	"Precondition: aPair must be of type (x@y), not a normal index."

	self at: aPair x at: aPair y put: aValue ! !

!Matriu methodsFor: 'operations' stamp: 'NatxoRaga 11/5/2012 23:45'!
identity

	^ self = (Matriu identity: self n)! !

!Matriu methodsFor: 'private' stamp: 'NatxoRaga 11/5/2012 01:21'!
indexForRow: aRow andColumn: aColumn
	"Return an array index for the specified row and column."
	"Remember that the matrix representation is done with only an array"

	^ (aRow - 1) * self n + aColumn ! !

!Matriu methodsFor: 'initialize-release' stamp: 'NatxoRaga 11/5/2012 01:20'!
initialize: aNumber
	"Initialize all the postions of the Matrix to the number 0"

	self n: aNumber.

	aNumber * aNumber timesRepeat: [self add: 0]

! !

!Matriu methodsFor: 'accessing' stamp: 'SomsBatallaAlex 11/1/2012 10:42'!
n

	^ n! !

!Matriu methodsFor: 'accessing' stamp: 'NatxoRaga 11/6/2012 17:41'!
n: aNumber

	n := aNumber! !

!Matriu methodsFor: 'printing' stamp: 'NatxoRaga 11/5/2012 21:22'!
printElementsOn: aStream
	"Override the previous function by printing each row on a different line."

	aStream nextPut: Character cr.
	(1 to: self n) do: [ :row | aStream nextPut: $(.
						       (1 to: self n) do: [ :col | aStream print: (self at: row at: col)] separatedBy: [aStream space].
						       aStream nextPut: $).
						       aStream nextPut: Character cr].
	! !

!Matriu methodsFor: 'operations' stamp: 'NatxoRaga 11/5/2012 23:38'!
symmetric

	^ self = self transposed ! !

!Matriu methodsFor: 'operations' stamp: 'NatxoRaga 11/9/2012 22:30'!
transposed

	| matTrans |

	matTrans := Matriu new: self n.	
	(1 to: self n) do: [ :row | 
		(1 to: self n) do: [ :col | matTrans at: (row@col) put: (self at: col@row)]].
	^ matTrans! !

Object subclass: #ParcialRagaLlorens
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Parcial<RagaLlorens>'!

!ParcialRagaLlorens class methodsFor: 'haltIf' stamp: 'NatxoRaga 11/7/2012 17:15'!
haltIf: aSelector

	| context |
	
	aSelector isSymbol ifTrue: 
		[context := thisContext.
		[context sender isNil] whileFalse: 
			[context := context sender.
			 (context selector = aSelector) ifTrue: [Halt signal].].
	 	^ self].! !

!ParcialRagaLlorens class methodsFor: 'preguntes teoria' stamp: 'NatxoRaga 11/9/2012 21:30'!
pregunta2

	| definicions reflexioSmalltalk reflexioJava comparacio |
	
	definicions := 'Reflexi: Habilitat d''un programa de manipular com a dades quelcom que representa l''estat del programa mentre aquest s''executa. Hi ha dos aspectes d''aquesta manipulaci: introspecci i intercessi.

Introspecci: Habilitat d''un programa d''observar, i per tant raonar, sobre el seu propi estat.

Intercessi: Habilitat d''un programa de modificar el seu propi estat o d''alterar la seva prpia interpretaci (semntica).

Reificaci: Mecanisme per codificar l''estat de l''execuci com a dades. Sense la reificaci, un llenguatge no tindria cap sistema per poder ser reflexiu, per tant s completament necessria.'.

	reflexioSmalltalk := 'Podriem dir que Smalltalk s un llenguatge que si no s reflexiu del tot, no li falta massa per ser-ho. Amb ell es pot fer tant introspecci (inspeccionar tant els objectes com el codi, accedir a la pila d''execuci, etc.) com intercessi (generar codi dinmicament o carregar-lo de manera lazy mitjanant el mtode #doesNotUnderstand:, etc.)'.
	
	reflexioJava := 	'En canvi, Java no s un llenguatge completament reflexiu, ja que encara que si pemet fer introspecci (amb algunes limitacions, com poden ser problemes a l''hora d''accedir al context d''execuci o culpa dels tipus primitius, arrays i interficies, que en molts casos fan que el mateix codi sigui ms brut que l''equivalent en Smalltalk), no permet fer intercessi real, sino que la simula mitjanant proxies.'.
		
	comparacio := 'Per tant, podem veure que a pesar que els dos llenguatges sn reflexius, la reflexi en Smalltalk surt d''una forma molt ms natural que no en Java, on tot sembla una mica ms forat (embolcalls per tipus primitius, moltes funcions isArray(), isPrimitive(), etc.), apart del fet que aquest ltim no disposa d''intercessi real.'.

	Transcript show: 'Definicions:'; cr; show: definicions; cr; cr; cr.
	Transcript show: reflexioSmalltalk; cr; show: reflexioJava; cr; cr.
	Transcript show: comparacio; cr; cr.! !

!ParcialRagaLlorens class methodsFor: 'preguntes teoria' stamp: 'NatxoRaga 11/9/2012 21:31'!
pregunta3

	| resposta |
	
	resposta := 'En SmallTalk, tota classe s instncia nica d''una metaclasse anomenada X class. Aquestes metaclasses estn ordenades en una jerarquia equivalent a la jerarquia de classes, i sn les que contenen la informaci de les classes (variables, mtodes, etc.).
A ms, les metaclasses hereten de Class (i per tant, de Behavior) i sn instncies (en SmallTalk tot s un objecte) de la classe Metaclass; per Metaclass tamb s una classe, per tant s instncia d''una metaclasse anomenada Metaclass class; per hem dit que totes les metaclasses sn instncies de Metaclass, el que crea un bucle curis: la classe Metaclass s instncia de Metaclass class, que alhora s instncia de Metaclass.

En Java la metaclasse Class (java.lang.Class) s la metaclasse base, i totes les classes sn instncies d''aquesta metaclasse. La metaclasse Class, en el seu lloc, es instncia d''ella mateixa, ja que tamb s una classe, i com a classe s instncia de la nica metaclasse del sistema: Class. Com podem veure, en Java noms hi ha una metaclasse (a diferncia de SmallTalk, on cada classe te la seva prpia metaclasse). Aix pot provocar problemes en la reflexi, ja que un canvi en la metaclasse general del sistema pot ocasionar conseqncies imprevisibles, mentre que en Smalltalk s molt menys perillos, al tenir una metaclasse per a cada classe.

Com que el disseny d''SmallTalk est pensat desde l''inici amb la reflexi en ment, aquesta sorgeix d''una forma molt ms natural grcies a la seva distribuci de metaclasses i a la forma en que ha estat creat. En SmallTalk la reflexi est inherent en el propi disseny del llenguatge. Aix no es aix en Java, on sembla que la reflexi ha estat ficada posteriorment (java.lang.reflect) i no forma part del disseny inicial del llenguatge, el que provoca que certes operacions que sn molt fcils de realitzar en SmallTalk costin molt ms en Java.'.

	Transcript show: resposta; cr; cr.! !

!ParcialRagaLlorens class methodsFor: 'preguntes teoria' stamp: 'NatxoRaga 11/9/2012 21:31'!
pregunta4

	| retorn elementsPila |
	
	retorn := 'Si el mtode m avalua la expressi ^expressi, aquesta retornar al mtode que ha cridat al mtode m. 
El problema apareix quan aquest ^expressi es troba a dintre d''un bloc. Un bloc s un closure, i com a tal captura el context semntic del lloc on es declarat. Per tant, si executem un bloc just quan aquest es declarat, el comportament ser semblant a si ^expressi es trobs a fora del bloc; pero en canvi, si aquest bloc es declara en un lloc i s''executa molt ms tard, l''expressi ^expressi retornar al lloc on s''havia declarat el bloc, no al lloc on s''ha avaluat.'.

	elementsPila := 'Els elements de la pila d''execuci que reifica thisContext sn instncia de la classe MethodContext, que representa tota la informaci (sender, receiver, etc.) d''un mtode (o d''un bloc).'.
	
	Transcript show: retorn; cr; cr.
	Transcript show: elementsPila; cr.! !

TestCase subclass: #MatriuTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Parcial<RagaLlorens>'!

!MatriuTest methodsFor: 'as yet unclassified' stamp: 'NatxoRaga 11/9/2012 22:04'!
testMultiplicacio

	| mat1 mat2 matMult |
	
	mat1 := Matriu new: 3.
	mat2 := Matriu new: 3.
	
	mat1 at: (1@1) put: 2;
		   at: (1@3) put: 7;
		   at: (2@1) put: 5;
		   at: (2@2) put: -8;
		   at: (3@2) put: 1.
		
	mat2 at: (1@2) put: 9;
		   at: (1@3) put: 1;
		   at: (2@1) put: -5;
		   at: (2@3) put: 1;
		   at: (3@2) put: 3.
		
	matMult := mat1 * mat2.
		
	self assert: (matMult at: 1@1) = 0;
		 assert: (matMult at: 1@2) = 39;
		 assert: (matMult at: 1@3) = 2;
		 assert: (matMult at: 2@1) = 40;
		 assert: (matMult at: 2@2) = 45;
		 assert: (matMult at: 2@3) = -3;
		 assert: (matMult at: 3@1) = -5;
		 assert: (matMult at: 3@2) = 0;
		 assert: (matMult at: 3@3) = 1.
		
	matMult := matMult * 2.
		
	self assert: (matMult at: 1@1) = 0;
		 assert: (matMult at: 1@2) = 78;
		 assert: (matMult at: 1@3) = 4;
		 assert: (matMult at: 2@1) = 80;
		 assert: (matMult at: 2@2) = 90;
		 assert: (matMult at: 2@3) = -6;
		 assert: (matMult at: 3@1) = -10;
		 assert: (matMult at: 3@2) = 0;
		 assert: (matMult at: 3@3) = 2.! !

!MatriuTest methodsFor: 'as yet unclassified' stamp: 'NatxoRaga 11/9/2012 21:52'!
testResta

| mat1 mat2 matResta |
	
	mat1 := Matriu new: 3.
	mat2 := Matriu new: 3.
	
	mat1 at: (1@1) put: 2;
		   at: (1@3) put: 7;
		   at: (2@1) put: 5;
		   at: (2@2) put: -8;
		   at: (3@2) put: 1.
		
	mat2 at: (1@2) put: 9;
		   at: (1@3) put: 1;
		   at: (2@1) put: -5;
		   at: (2@3) put: 1;
		   at: (3@2) put: 3.
		
	matResta := mat1 - mat2.
		
	self assert: (matResta at: 1@1) = 2;
		 assert: (matResta at: 1@2) = -9;
		 assert: (matResta at: 1@3) = 6;
		 assert: (matResta at: 2@1) = 10;
		 assert: (matResta at: 2@2) = -8;
		 assert: (matResta at: 2@3) = -1;
		 assert: (matResta at: 3@1) = 0;
		 assert: (matResta at: 3@2) = -2;
		 assert: (matResta at: 3@3) = 0.
		
	matResta := matResta -2.
		
	self assert: (matResta at: 1@1) = 0;
		 assert: (matResta at: 1@2) = -11;
		 assert: (matResta at: 1@3) = 4;
		 assert: (matResta at: 2@1) = 8;
		 assert: (matResta at: 2@2) = -10;
		 assert: (matResta at: 2@3) = -3;
		 assert: (matResta at: 3@1) = -2;
		 assert: (matResta at: 3@2) = -4;
		 assert: (matResta at: 3@3) = -2.! !

!MatriuTest methodsFor: 'as yet unclassified' stamp: 'NatxoRaga 11/9/2012 21:51'!
testSuma

	| mat1 mat2 matSuma |
	
	mat1 := Matriu new: 3.
	mat2 := Matriu new: 3.
	
	mat1 at: (1@1) put: 2;
		   at: (1@3) put: 7;
		   at: (2@1) put: 5;
		   at: (2@2) put: -8;
		   at: (3@2) put: 1.
		
	mat2 at: (1@2) put: 9;
		   at: (1@3) put: 1;
		   at: (2@1) put: -5;
		   at: (2@3) put: 1;
		   at: (3@2) put: 3.
		
	matSuma := mat1 + mat2.
		
	self assert: (matSuma at: 1@1) = 2;
		 assert: (matSuma at: 1@2) = 9;
		 assert: (matSuma at: 1@3) = 8;
		 assert: (matSuma at: 2@1) = 0;
		 assert: (matSuma at: 2@2) = -8;
		 assert: (matSuma at: 2@3) = 1;
		 assert: (matSuma at: 3@1) = 0;
		 assert: (matSuma at: 3@2) = 4;
		 assert: (matSuma at: 3@3) = 0.
		
	matSuma := matSuma + 3.
	
	self assert: (matSuma at: 1@1) = 5;
		 assert: (matSuma at: 1@2) = 12;
		 assert: (matSuma at: 1@3) = 11;
		 assert: (matSuma at: 2@1) = 3;
		 assert: (matSuma at: 2@2) = -5;
		 assert: (matSuma at: 2@3) = 4;
		 assert: (matSuma at: 3@1) = 3;
		 assert: (matSuma at: 3@2) = 7;
		 assert: (matSuma at: 3@3) = 3.! !

!MatriuTest methodsFor: 'as yet unclassified' stamp: 'NatxoRaga 11/9/2012 22:29'!
testTransposed

| mat1 matTrans |
	
	mat1 := Matriu new: 3.
	
	mat1 at: (1@1) put: 2;
		   at: (1@3) put: 7;
		   at: (2@1) put: 5;
		   at: (2@2) put: -8;
		   at: (3@2) put: 1.
		
	matTrans := mat1 transposed.
	
	self assert: (matTrans at: 1@1) = 2;
		 assert: (matTrans at: 1@2) = 5;
		 assert: (matTrans at: 1@3) = 0;
		 assert: (matTrans at: 2@1) = 0;
		 assert: (matTrans at: 2@2) = -8;
		 assert: (matTrans at: 2@3) = 1;
		 assert: (matTrans at: 3@1) = 7;
		 assert: (matTrans at: 3@2) = 0;
		 assert: (matTrans at: 3@3) = 0.
	
	 ! !
